package com.web.api.config;

import lombok.extern.slf4j.Slf4j;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;

import java.util.concurrent.Executor;
import java.util.concurrent.ThreadPoolExecutor;

/**
 * @author 王玉鹏
 * @version 1.0
 * @className ExecturConfig
 * @description TODO
 * @date 2020/1-2/14 9:37
 */
@Configuration
@Slf4j
public class ExecturConfig {
    @Bean("asyncServiceExecutor")
    public Executor taskExector() {
        log.info("开始启动异步任务线程池……");
        ThreadPoolTaskExecutor executor = new ThreadPoolTaskExecutor();
        //获取到服务器的cpu内核
        int i = Runtime.getRuntime().availableProcessors();
        log.info("当前cpu内核数：【{}】",i);
        //核心池大小
        executor.setCorePoolSize(10);
        //最大线程数
        executor.setMaxPoolSize(300);
        //队列程度
        executor.setQueueCapacity(1);
        //线程空闲时间
        executor.setKeepAliveSeconds(300);
        //线程前缀名称
        executor.setThreadNamePrefix("task-async-");
        //配置拒绝策略
        executor.setRejectedExecutionHandler(new ThreadPoolExecutor.AbortPolicy());
        executor.initialize();
        log.info("异步线程前缀名称:{},当前线程池的线程数量:【{}】, 当前活动线程数量 【{}】",
                executor.getThreadNamePrefix(),
                executor.getPoolSize(),
                executor.getActiveCount());
        return executor;
    }
}
