

package com.web.api.config;

import com.github.xiaoymin.swaggerbootstrapui.annotations.EnableSwaggerBootstrapUI;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import springfox.documentation.builders.ApiInfoBuilder;
import springfox.documentation.builders.ParameterBuilder;
import springfox.documentation.builders.PathSelectors;
import springfox.documentation.builders.RequestHandlerSelectors;
import springfox.documentation.schema.ModelRef;
import springfox.documentation.service.ApiInfo;
import springfox.documentation.service.Contact;
import springfox.documentation.spi.DocumentationType;
import springfox.documentation.spring.web.plugins.Docket;
import springfox.documentation.swagger2.annotations.EnableSwagger2;

import java.util.ArrayList;
import java.util.List;


/**
 * @author 王玉鹏
 * @version 1.0
 * @className Swagger2Config
 * @description TODO
 * @date 2019/12/25 16:46
**/



@Configuration
@EnableSwagger2
@EnableSwaggerBootstrapUI
public class Swagger2Config{

 /*   @Value("${swagger.show}")
    boolean swaggerShow;*/


    @Bean
    public Docket createRestApi() {

        ParameterBuilder gParameterBuilder = new ParameterBuilder();
        gParameterBuilder.parameterType("header");
        gParameterBuilder.name("token");
        gParameterBuilder.modelRef(new ModelRef("String")).required(false).build();
        List<ParameterBuilder> aParameters = new ArrayList<ParameterBuilder>();
        aParameters.add(gParameterBuilder);
        List<springfox.documentation.service.Parameter> gParameters = new ArrayList<>();
        gParameters.add(gParameterBuilder.build());
        return new Docket(DocumentationType.SWAGGER_2)
                //正式服务器设置为false
                .enable(true)
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.web.api.controller"))
                .paths(PathSelectors.any())
                .build().globalOperationParameters(gParameters);
    }

    private ApiInfo apiInfo() {
        return new ApiInfoBuilder()
                .title("大美州后台api")
                .description("大美州后台api")
                .contact(new Contact("wyp", "http://www.baidu.com", ""))
                .version("1.0")
                .build();
    }

}


