package com.web.api.exception;

/**
 * @author 王玉鹏
 * @version 1.0
 * @className UnauthorizedException
 * @description TODO
 * @date 2020/1/17 13:45
 */
public class UnauthorizedException extends RuntimeException implements IException {
    private static final long serialVersionUID = 4286015280221509266L;
    protected String code;
    protected Object data;
    private String nativeMessage;
    private Object[] arguments;

    public UnauthorizedException() {
    }

    public UnauthorizedException(String message) {
        super(message);
    }

    public UnauthorizedException(String message, Throwable cause) {
        super(message, cause);
    }

    public String getMessage() {
        return this.nativeMessage == null ? super.getMessage() : this.nativeMessage;
    }

    public Object getData() {
        return this.data;
    }

    public UnauthorizedException(String code, String message) {
        super(message);
        this.code = code;
    }

    public UnauthorizedException(String code, Object data) {
        this.code = code;
        this.data = data;
    }

    public UnauthorizedException(String code, String message, Object data) {
        super(message);
        this.code = code;
        this.data = data;
    }

    public UnauthorizedException(String code, String message, Throwable cause) {
        super(message, cause);
        this.code = code;
    }

    public UnauthorizedException(String code, String message, String nativeMessage) {
        super(message);
        this.code = code;
        this.nativeMessage = nativeMessage;
    }

    public UnauthorizedException(String code, String message, String nativeMessage, Throwable cause) {
        super(message, cause);
        this.code = code;
        this.nativeMessage = nativeMessage;
    }

    public UnauthorizedException(String code, Object... arguments) {
        this.code = code;
        this.arguments = arguments;
    }

    public UnauthorizedException(String code, String msg, Object... arguments) {
        super(msg);
        this.code = code;
        this.arguments = arguments;
    }

    public void setArguments(Object... arguments) {
        this.arguments = arguments;
    }

    public Object[] getArguments() {
        return this.arguments;
    }

    public String getCode() {
        return this.code;
    }

    public String getNativeMessage() {
        return this.nativeMessage;
    }
}