package com.web.api.job;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.web.api.controller.answer.croe.HttpEntityType;
import com.web.api.controller.answer.croe.HttpRequestConfig;
import com.web.api.utils.HttpClientUtils;
import okhttp3.*;
import okhttp3.sse.EventSource;
import okhttp3.sse.EventSourceListener;
import okhttp3.sse.EventSources;
import okio.BufferedSink;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class ChatBot35Stream {
    private static final String API_ENDPOINT = "https://api.openai.com/v1/chat/completions";
    private static final String API_KEY = "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";

    static List<JSONObject>  messages = new ArrayList<>();

    public static void main(String[] args) throws Exception {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));

        System.out.println("您好，我是 ChatBot，请问有什么可以帮助您的吗？");


        JSONObject msg = new JSONObject();
        msg.put("role","system");
        msg.put("content","你是一个友善的助手");
        messages.add(msg);
        while (true) {
            System.out.print("> ");
            String input = reader.readLine().trim();

            if (input.isEmpty()) {
                continue;
            }
            if (messages.size()>=10){
                messages.clear();
            }
              getResponse(input);
//            System.out.println("ChatBot: " + response);
//            JSONObject res = JSON.parseObject(response, JSONObject.class);
//            String choices = res.getString("choices");
//            String usage = res.getString("usage");
//            System.out.println("usage: "+usage);
//            List<JSONObject> list = JSON.parseArray(choices, JSONObject.class);
//            list.forEach(e->{
//                String message = e.getString("message");
//                JSONObject content = JSON.parseObject(message, JSONObject.class);
//                messages.add(content);
//                System.out.println("content:"+content.getString("content"));
//            });
        }
    }

    private static void getResponse(String input) throws Exception {
        OkHttpClient okHttpClient = new OkHttpClient();
        EventSource.Factory factory = EventSources.createFactory(okHttpClient);
        StringBuilder str = new  StringBuilder();
        EventSourceListener eventSourceListener = new EventSourceListener() {
            @Override
            public void onClosed(@NotNull EventSource eventSource) {
                System.out.println("see连接关闭……");
                super.onClosed(eventSource);
            }

            @Override
            public void onEvent(@NotNull EventSource eventSource, @Nullable String id, @Nullable String type, @NotNull String data) {
//                System.out.println("time:"+new Date()+"id:"+id+",data:"+data);
                if (!data.equals("[DONE]")){
                    JSONObject res = JSON.parseObject(data, JSONObject.class);
                    List<JSONObject> list = JSON.parseArray(res.getString("choices"), JSONObject.class);
                    list.forEach(e->{
                        JSONObject delta = JSON.parseObject(e.getString("delta"), JSONObject.class);
                        System.out.print(delta.getString("content"));
                    });
                }else {
                    System.out.println("DONE");
                }
                super.onEvent(eventSource, id, type, data);
            }

            @Override
            public void onFailure(@NotNull EventSource eventSource, @Nullable Throwable t, @Nullable Response response) {
               t.printStackTrace();
                super.onFailure(eventSource, t, response);
            }

            @Override
            public void onOpen(@NotNull EventSource eventSource, @NotNull Response response) {
                super.onOpen(eventSource, response);
                System.out.println("建立see连接……");
            }
        };

        String data = "{\n" +
                "    \"model\": \"gpt-3.5-turbo\",\n" +
                "    \"stream\": true,\n" +
                "    \"messages\": [{\"role\": \"user\", \"content\": \""+input+"\"}]\n" +
                "  }";

        Request request = new Request.Builder().url(API_ENDPOINT)
                .header("Authorization", "Bearer " + API_KEY)
                .post(RequestBody.create(data,MediaType.parse("application/json")))
                .build();
        factory.newEventSource(request, eventSourceListener);
    }
}
