package com.web.api.model.dto;

import com.web.api.exception.BusinessException;
import com.web.api.model.po.InsuranceOrder;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.util.StringUtils;

import java.util.List;
import java.util.Map;

/**
 * @author 王玉鹏
 * @version 1.0
 * @className InsuranceOrderDto
 * @description TODO
 * @date 2020/1/2 21:18
 */
@Data
public class InsuranceOrderDto {
    private String id;
    private String userId;
    /**保险公司名称*/
    private String insuranceName;
    /**客服咨询电话*/
    private String telephone;
    /**保险公司连接*/
    private String insuranceHref;
    /**险种名称*/
    private String insuranceType;
    /**保单号*/
    private String orderNo;
    /**基本保障金额*/
    private String baseInsuranceMoney;
    /**意外医疗保险金额*/
    private String accidentInsuranceMoney;
    /**保费合计金额*/
    private String  insuranceMoney;
    /**保险开始时间*/
    private String  insuranceStartDate;
    /**保险结束时间*/
    private String insuranceEndDate;
    /**保险附件(最多三张)*/
    private List<Map<String,String>> fileList;

    public InsuranceOrder geInsuranceOrderParamers() {
        InsuranceOrder insuranceOrder = new InsuranceOrder();
        if (StringUtils.isEmpty(this.insuranceName)) {
            throw new BusinessException("保险公司名称不能为空");
        }if (StringUtils.isEmpty(this.telephone)) {
            throw new BusinessException("客服咨询电话不能为空");
        } else if (StringUtils.isEmpty(this.orderNo)) {
            throw new BusinessException("保单号不能为空");
        } else if (StringUtils.isEmpty(this.insuranceMoney)) {
            throw new BusinessException("保费合计金额不能为空");
        }else if (StringUtils.isEmpty(this.insuranceStartDate)) {
            throw new BusinessException("保险开始时间不能为空");
        }else if (StringUtils.isEmpty(this.insuranceEndDate)) {
            throw new BusinessException("保险结束时间不能为空");
        }else {
            BeanUtils.copyProperties(this,insuranceOrder);
        }
        return insuranceOrder;
    }
}
