package com.web.api.model.po;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.ToString;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import java.io.Serializable;

/**
 * @author 王玉鹏
 * @version 1.0
 * @className content
 * @description TODO
 * @date 2019/12/23 15:20
 */

@AllArgsConstructor
@ToString
@NoArgsConstructor
@Entity
@Data
public class Content implements Serializable {
    /** 新闻id*/
    @Id
    private String contentId;
    /** 标题*/
    private String title;
    /** 新闻主体*/
    private String content;
    /** 图片路径*/
    @Column(name = "image_path")
    private String imagePath;
    /** 点击量*/
    private Integer hits;
    /** 排序（0-999），数组越大排序越高*/
    private Integer sort;
    /** 创建日期*/
    private String createDate;
    /** 最后更新日期*/
    private String updateDate;

    public Content(String contentId) {
        this.contentId = contentId;
    }
}
