package com.web.api.service;

import com.web.api.model.dto.AnswerDto;
import com.web.api.model.dto.SearchDto;
import com.web.api.model.po.AnswerRecord;
import com.web.api.model.po.UserInfo;
import org.apache.http.client.CookieStore;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.List;
import java.util.Map;

/**
 * @author 王玉鹏
 */
public interface AnswerService {
    CookieStore login(String username, String password, String safeCode) throws Exception;

    UserInfo getUserInfo(String jobNo, CookieStore cookieStore) throws Exception;

    void answer(CookieStore cookieStore, AnswerDto answerDto) throws Exception;

    Map<String, Object> getAnwserInfo(String jobNo, CookieStore cookieStore) throws Exception;

    void stopAnswer(String jobNo, CookieStore cookieStore) throws Exception;

    void logOut(String jobNo, CookieStore cookieStore) throws Exception;

    String ranking(String jobNo, CookieStore cookieStore) throws Exception;

    String exportExcel(SearchDto searchDto) throws Exception;

    List<AnswerRecord> search(SearchDto searchDto);

    String importExcel(MultipartFile file) throws IOException;

    String updateTime(int time) throws Exception;

    Object getLimitTime() throws Exception;

    Object getForbidden(String jobNo) throws Exception;

    boolean updateForbiddenStatus(String jobNo, Boolean status, int bus) throws Exception;

    boolean resetPassword(String jobNo) throws Exception;

    List<Map<String, Object>> queryBlacklist() throws Exception;

    void clearAdminCookie() throws Exception;
}
